

#pragma once
#ifndef DEBUG_HPP
#define DEBUG_HPP

#include <queue>
#include <fstream>

//#include "Globals.hpp"
#include "String.hpp"

//#ifdef UNICODE
//const int CHAR_SIZE = sizeof(wchar_t);
//#else
//const int CHAR_SIZE = sizeof(char);
//#endif

class Debug
{
public:
	Debug()
		//: file(0)
	{}
	Debug(STRING f)
	{
		Open(f);
	}
	~Debug()
	{
		Close();
	}
	// Open debug
	void Open(STRING f)
	{
		if (file.is_open())
			Close();
		//WOPEN(file, f);
		file.open(f.c_str());
		Flush();
	}
	void Close()
	{
		Flush();
		file.close();
		/*if (file)
		{
			fclose(file);
			file = 0;
		}*/
	}
	// Append log
	void Log(STRING str)
	{
		buffer.push(str);
		if (file.is_open())
			Flush();
	}
	// Flush the buffer
	void Flush()
	{
		while (!buffer.empty())
		{
			std::string str;
			STRING top = buffer.front();
			str.assign(top.begin(), top.end());
			//str.append(STR("\r\n"));
			//fwrite(str.c_str(), CHAR_SIZE, str.size(), file);
			file << str.c_str() << std::endl;
			buffer.pop();
		}
		file.flush();
		//fflush(file);
	}
private:
	//FILE * file;
	std::ofstream file;
	std::queue<STRING> buffer;
};

#endif // DEBUG_HPP