

#pragma once
#ifndef NUMBER_HPP
#define NUMBER_HPP

#include <string>

// Type definitions
typedef unsigned char BYTE;
typedef unsigned int UINT;
typedef long long INT64;
typedef int COORDS;

namespace Port
{
	// Sets a separator for a number
	std::string setSeparator(INT64 number, char c = ',');

	// Sets a separator for a number
	std::string setSeparator(int number, char c = ',');

	// Sets a separator for a string
	std::string setSeparator(std::string str, char c = ',');
}

#endif // NUMBER_HPP