

#pragma once
#ifndef THREAD_HPP
#define THREAD_HPP
#include <queue>
#include "ThreadPool.hpp"

//typedef void * PORT_THREAD;

/*namespace Port
{
	PORT_THREAD CreateThread(void * (*func)(void *), void * data);

	bool WaitThread(PORT_THREAD id = (PORT_THREAD)-1, unsigned int timeout = -1);

	void CloseThread(PORT_THREAD id);
}*/

typedef RESULT (*THREAD_FUNC)(WORK order);

class Thread
{
public:
	Thread();
	~Thread();

	void Initialize(THREAD_FUNC func);
	

private:
	void * thread;
	bool process;

	std::queue<WORK> work;
	std::queue<RESULT> result;
};

#endif // THREAD_HPP