

#include "Chunk.hpp"

#include <string.h>

Chunk::Counter::Counter()
{
	//memset(this, 0, sizeof(Chunk::Counter));
	memset(block, 0, sizeof(INT64) * BLOCKAMOUNT_MAX);
	filesize = 0;
}
Chunk::Counter & Chunk::Counter::operator=(const Chunk::Counter &c)
{
	if (this == &c)
		return *this;
	//memcpy(this, &c, sizeof(Chunk::Counter));
	memcpy(this, &c.block, sizeof(INT64) * BLOCKAMOUNT_MAX);
	mobs = c.mobs;
	filesize = c.filesize;
	return *this;
}
Chunk::Counter & Chunk::Counter::operator+=(const Chunk::Counter &c)
{
	for (int i = 0; i < BLOCKAMOUNT_MAX; ++i)
		block[i] += c.block[i];
	for (std::map<std::string, INT64>::const_iterator i = c.mobs.begin(); i != c.mobs.end(); ++i)
	{
		std::map<std::string, INT64>::iterator n = mobs.find(i->first);
		if (n != mobs.end())
		{
			n->second += i->second;
		}
		else
		{
			mobs[i->first] = i->second;
		}
	}
	/*chicken += c.chicken;
	sheep += c.sheep;
	zombie += c.zombie;
	pig += c.pig;
	skeleton += c.skeleton;
	creeper += c.creeper;
	cow += c.cow;
	slime += c.slime;
	pigzombie += c.pigzombie;
	ghast += c.ghast;*/

	filesize += c.filesize;
	return *this;
}
const Chunk::Counter & Chunk::Counter::operator+(const Chunk::Counter &c) const
{
	Chunk::Counter result = *this;
	result += c;
	return *this;
}