

#pragma once
#ifndef LISTFILES_HPP
#define LISTFILES_HPP

//#include "Globals.hpp"
#include "String.hpp"

#include <string.h>
#include <vector>
#include <stack>

// List files through function
struct FileSearch
{
	FileSearch();
	STRING path;
	std::stack<STRING> files;
	std::vector<STRING> exclude;
	size_t * amount;
	bool deep;
};

// List files
bool ListFiles(FileSearch * prefs);

// List files through class
class Files
{
public:
	Files(STRING path, bool sub);
	~Files();

	bool NextFile(STRING & file);

	std::vector<STRING> exclude;
	size_t GetAmount() {return amount;}
private:
	STRING startPath;
	bool sub;
	std::stack<STRING> directories;
	STRING currentPath;
	STRING currentFile;
	
	size_t amount;

	void * data;

	bool OpenNextDir();
	bool FindFile();
	bool FindNext();
	bool FoundFile(STRING & returnFile);
	bool IsExcluded();
	bool IsDirOpen();
};

#endif // LISTFILES_HPP